/*
 * Auteur : Yosko, http://www.yosko.net/
 * Date : 03/09/2012
 * 
 * Exemple d'utilisation du QSignalMapper avec des widgets créés dynamiquement
 * 
 */

#include "mainwindow.h"

MainWindow::MainWindow() : QWidget() {
    QVBoxLayout *mainLayout = new QVBoxLayout;
    this->setLayout(mainLayout);

    //Lecture du fichier .ini
    QSettings iniFile("DynamicWidgets.ini", QSettings::IniFormat);
    iniFile.beginGroup("Buttons");

    //Déclaration du mapper, qu'on connecte au slot
    QSignalMapper *signalMapper = new QSignalMapper(this);
    QObject::connect(signalMapper, SIGNAL(mapped(QString)), this, SLOT(displayButton(QString)));

    //Lecture d'un tableau de clés
    foreach(QString key, iniFile.childKeys()) {
        //Récupération du nom du bouton
        QString buttonName(iniFile.value(key,"").toString());
        QPushButton *button = new QPushButton;
        button->setText(buttonName);
        mainLayout->addWidget(button);

        //Mappage, puis connexion du signal au mapper
        signalMapper->setMapping(button, buttonName);
        QObject::connect(button, SIGNAL(clicked()), signalMapper, SLOT(map()));
    }
    iniFile.endGroup();
}

void MainWindow::displayButton(QString buttonName) {
    QMessageBox::information(this, "Bouton", QString("Bouton \"" + buttonName + "\" cliqué !"));
}
